DerethForever.Web/Controllers/ResourceController.cs
/*****************************************************************************************
Copyright 2018 Dereth Forever

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons
to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE.
*****************************************************************************************/
using System;
using System.Configuration;
using System.IO;
using System.Web.Mvc;
using Lifestoned.DataModel.Gdle;
using Lifestoned.DataModel.WorldRelease;
using Lifestoned.Lib.ClientLib.Enum;
using Lifestoned.Providers;

namespace DerethForever.Web.Controllers
{
    public class ResourceController : BaseController
    {
        public ActionResult GetFullyLayeredPngIcon(uint weenieClassId)
        {
            byte[] src = new byte[] { };

            if (weenieClassId > 0)
            {
                try
                {
                    var weenie = ContentProviderHost.GetContent(WeenieChange.TypeName, weenieClassId) as Weenie;
                    ////var weenie = ContentProviderHost.CurrentProvider.GetWeenie(null, weenieClassId);
                    src = Lifestoned.Lib.ResourceManager.GetFullyLayeredPngIcon(weenie.ItemType, weenie.UnderlayId, weenie.OverlayId, weenie.IconId, weenie.UIEffects);
                }
                catch (Exception)
                {
                    return null;
                }
            }

            return File(src, "image/png");
        }

        [HttpGet]
        public ActionResult GetDynamicIcon(int? itemType, uint? underlayId, uint? overlayId, uint? iconId, int? uiEffects)
        {
            byte[] src = new byte[] { };
            src = Lifestoned.Lib.ResourceManager.GetFullyLayeredPngIcon(itemType, underlayId, overlayId, iconId, uiEffects);
            return File(src, "image/png");
        }

        [HttpGet]
        public ActionResult GetImage(uint imageId)
        {
            byte[] src = new byte[] { };

            if (imageId > 0)
            {
                try
                {
                    src = Lifestoned.Lib.ResourceManager.GetPngImage(imageId);
                }
                catch (Exception)
                {
                    return null;
                }
            }

            return File(src, "image/png");
        }

        ////[HttpGet]
        ////public ActionResult GetCurrentWorldRelease()
        ////{
        ////    byte[] src = new byte[] { };
        ////    Release info = new Release();

        ////    try
        ////    {
        ////        info = ContentProviderHost.CurrentProvider.GetCurrentWorldReleaseInfo(GetUserToken());
        ////        src = ContentProviderHost.CurrentProvider.GetCurrentWorldRelease(GetUserToken());
        ////    }
        ////    catch (Exception)
        ////    {
        ////        return null;
        ////    }

        ////    return File(src, "application/zip", info.FileName);
        ////}

        ////[HttpGet]
        ////public ActionResult GetWorldRelease(string fileName)
        ////{
        ////    byte[] src = new byte[] { };

        ////    if (fileName?.Length > 0)
        ////    {
        ////        try
        ////        {
        ////            src = ContentProviderHost.CurrentProvider.GetWorldRelease(GetUserToken(), fileName);
        ////        }
        ////        catch (Exception)
        ////        {
        ////            return null;
        ////        }
        ////    }

        ////    return File(src, "application/zip");
        ////}

        ////[HttpGet]
        ////public ActionResult GetCurrentWorldReleaseInfo()
        ////{
        ////    Release releaseInfo = new Release() { Type = ReleaseType.Unknown };

        ////    try
        ////    {
        ////        releaseInfo = ContentProviderHost.CurrentProvider.GetCurrentWorldReleaseInfo(GetUserToken());
        ////    }
        ////    catch (Exception)
        ////    {
        ////        return null;
        ////    }

        ////    return Json(releaseInfo);
        ////}

        ////[HttpGet]
        ////public ActionResult GetWorldReleaseInfo(string fileName)
        ////{
        ////    Release src = new Release() { Type = ReleaseType.Unknown };

        ////    if (fileName?.Length > 0)
        ////    {
        ////        try
        ////        {
        ////            src = ContentProviderHost.CurrentProvider.GetWorldReleaseInfo(GetUserToken(), fileName);
        ////        }
        ////        catch (Exception)
        ////        {
        ////            return null;
        ////        }
        ////    }

        ////    return Json(src);
        ////}
    }
}

DerethForever.Web/Controllers/WeenieController.cs
/*****************************************************************************************
Copyright 2018 Dereth Forever

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons
to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE.
*****************************************************************************************/
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Web;
using System.Web.Mvc;
using DerethForever.Web.Models.Discord;
using log4net;
using Lifestoned.DataModel.Gdle;
using Newtonsoft.Json;
using RestSharp;
using Lifestoned.DataModel.Shared;
using Lifestoned.DataModel.Account;
using Lifestoned.Providers;

namespace DerethForever.Web.Controllers
{
    public class WeenieController : BaseController
    {
        private const string _Session_IndexModel = "__weenieIndexModel";
        private const string _Session_DownloadModel = "__weenieDownloadModel";

        private static readonly ILog log = LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);

        private IWeenieProvider Provider => ContentProviderHost.GetProvider<IWeenieProvider>(WeenieChange.TypeName);

        private IWeenieSandboxProvider SandboxProvider => SandboxContentProviderHost.GetProvider<IWeenieSandboxProvider>(WeenieChange.TypeName);

        public IndexModel CurrentIndexModel
        {
            get { return (IndexModel)Session[_Session_IndexModel]; }
            set { Session[_Session_IndexModel] = value; }
        }

        public DownloadChangeModel CurrentDownload
        {
            get { return (DownloadChangeModel)Session[_Session_DownloadModel]; }
            set { Session[_Session_DownloadModel] = value; }
        }

        private Weenie GetWeenieForUser(uint id, string userGuid)
        {
            WeenieChange wc = null;
            ViewBag.UserGuid = null;
            string userToken = GetUserToken();

            if (!string.IsNullOrEmpty(userToken))
            {
                if (string.IsNullOrWhiteSpace(userGuid))
                {
                    Guid uid = new Guid(GetUserGuid());
                    // no userGuid specified, assume your own sandbox
                    ////wc = SandboxContentProviderHost.CurrentProvider.GetMySandboxedChange(GetUserToken(), id);
                    wc = SandboxProvider.GetChange(uid, id) as WeenieChange;
                }
                else
                {
                    // validate dev/admin or matches your id
                    if (User.IsInRole("Developer") || GetUserGuid() == userGuid)
                        wc = SandboxProvider.GetChange(new Guid(userGuid), id) as WeenieChange;
                    ////wc = SandboxContentProviderHost.CurrentProvider.GetSandboxedChange(Guid.Parse(userGuid), id);
                    else
                        return null;
                }
            }

            Weenie weenie = null;
            if (wc != null)
            {
                weenie = wc.Entry;
                ViewBag.UserGuid = userGuid;
            }
            else
                weenie = Provider.Get(id);
            ////weenie = SandboxContentProviderHost.CurrentProvider.GetWeenie(GetUserToken(), id);

            return weenie;
        }

        [HttpGet]
        public ActionResult SpellList()
        {
            return View("SpellListPopup");
        }

        [HttpGet]
        public ActionResult Recent()
        {
            IndexModel model = CurrentIndexModel ?? new IndexModel();
            ////model.Results = SandboxContentProviderHost.CurrentProvider.RecentChanges(GetUserToken());

            model.Results = Provider.Search(w => w.LastModified >= DateTime.Now.Date.AddDays(-90), 100).OrderByDescending(w => w.LastModified)
                .Select(w => w.ToSearchResult()).ToList();

            return View(model);
        }

        ////[HttpGet]
        ////public ActionResult AllUpdates()
        ////{
        ////    var allUpdates = SandboxContentProviderHost.CurrentProvider.AllUpdates(GetUserToken());
        ////    var zipFile = new ZipFile();
        ////    foreach (var update in allUpdates)
        ////    {
        ////        // build the CachePwn json for this weenie
        ////        var weenie = SandboxContentProviderHost.CurrentProvider.GetWeenie(GetUserToken(), update.WeenieClassId);
        ////        // var cachePwn = Weenie.ConvertFromWeenie(weenie);
        ////        var settings = new JsonSerializerSettings { NullValueHandling = NullValueHandling.Ignore };
        ////        var contents = JsonConvert.SerializeObject(weenie, Formatting.None, settings);

        ////        // build filename
        ////        var name = weenie.Name;
        ////        var removeChars = new List<string>() { "\t", "\n", "!", "\"" };
        ////        foreach (var removeChar in removeChars)
        ////            name = name.Replace(removeChar, "");

        ////        var filename = $"{update.WeenieClassId} - {name}.json";

        ////        // add json to zip file
        ////        zipFile.AddFile(filename, contents);
        ////    }

        ////    var bytes = zipFile.BuildZip();
        ////    string date = string.Format("{0:yyyy-MM-dd_hh-mm}", DateTime.Now);
        ////    return File(bytes, "application/zip", "GDLE-Latest-Updates-" + date + ".zip");
        ////}

        [HttpGet]
        public ActionResult Detail(uint id, string userGuid)
        {
            Weenie weenie = GetWeenieForUser(id, userGuid);

            if (weenie == null)
                return new HttpNotFoundResult();

            return View(weenie);
        }

        [HttpGet]
        public ActionResult Index()
        {
            IndexModel model = CurrentIndexModel ?? new IndexModel();
            BaseModel current = CurrentBaseModel;
            BaseModel.CopyBaseData(current, model);
            CurrentBaseModel = current;

            return View(model);
        }

        [HttpPost]
        public ActionResult Index(IndexModel model)
        {
            if (!ModelState.IsValid)
                return View(model);

            try
            {
                var criteria = ProcessSearchCriteria(model.Criteria);

                ////string token = GetUserToken();
                if (User.Identity.IsAuthenticated)
                {
                    Guid uid = new Guid(GetUserGuid());
                    model.Results = SandboxProvider.Search(uid, criteria).Select(w => w.ToSearchResult()).ToList();
                }
                else
                {
                    model.Results = Provider.Search(criteria).Select(w => w.ToSearchResult()).ToList();
                }

                ////model.Results = SandboxContentProviderHost.CurrentProvider.WeenieSearch(token, model.Criteria);

                ////if (!string.IsNullOrEmpty(token))
                ////{
                ////    List<WeenieChange> mine = SandboxContentProviderHost.CurrentProvider.GetMyWeenieChanges(GetUserToken());
                ////    model.Results.ForEach(w =>
                ////    {
                ////        if (mine.Any(m => m.Entry.WeenieClassId == w.WeenieClassId))
                ////            w.HasSandboxChange = true;
                ////    });
                ////}

                model.ShowResults = true;
            }
            catch (Exception ex)
            {
                model.Results = null;
                model.ShowResults = false;
                model.ErrorMessages.Add("Error retrieving data from the SandboxContentProviderHost");
                model.Exception = ex;
            }

            return View(model);
        }

        [HttpGet]
        public ActionResult Get(uint id, string userGuid)
        {
            Weenie weenie = GetWeenieForUser(id, userGuid);

            if (weenie == null)
                return new HttpNotFoundResult();

            SortTheThings(weenie);
            return JsonGet(weenie);
        }

        [HttpPut]
        [Authorize]
        public ActionResult Put(Weenie model)
        {
            ModelState.Clear();
            // TODO: Better Validation
            ActionResult result = ValidateWeenie(model);

            if (result != null)
            {
                ModelState.Clear();
                return ErrorResult("Validation Failed");
            }

            model.CleanDeletedAndEmptyProperties();
            model.LastModified = DateTime.Now;
            model.ModifiedBy = GetUserName();

            try
            {
                SandboxProvider.UpdateChange(new Guid(GetUserGuid()), model);
                ////SandboxContentProviderHost.CurrentProvider.UpdateWeenie(GetUserToken(), model);

                IndexModel indexModel = new IndexModel();
                indexModel.SuccessMessages.Add("Weenie " + model.WeenieClassId.ToString() + " successfully saved.");
                CurrentIndexModel = indexModel;

                ////return SandboxAction();
                return OkResult();
            }

DerethForever.Web/Views/Weenie/Delete.cshtml
@using DerethForever.Web.Controllers;
@using Lifestoned.DataModel.Gdle;
@using Lifestoned.DataModel.Shared;
@model Weenie

@{
    ViewBag.Title = "Delete " + Model.Name;
}

<br />

<h4>Confirm deletion of @(Html.Raw(Model.Name)), @(Html.Raw(Model.WeenieClassId))?</h4>

<br />

@Html.DisplayFor(m => m, "InfoMessages")

@using (Html.BeginForm("Delete", "Weenie", FormMethod.Post))
{
    @Html.AntiForgeryToken()
    @Html.HiddenFor(m => m.WeenieClassId)
    @Html.HiddenFor(m => m.MvcAction)

    <button class="btn btn-danger" id="btnDelete">Delete</button>
    <button class="btn btn-warning" id="btnCancel">Cancel</button>
}

@section scripts {
    <script language="javascript">
        $("#btnDelete").on("click", function () {
            $("#MvcAction").val(@((int)WeenieCommands.Delete));
            $("form").submit();
        });

        $("#btnCancel").on("click", function () {
            $("#MvcAction").val(@((int)WeenieCommands.Cancel));
            $("form").submit();
        });
    </script>
}

DerethForever.Web/Views/Weenie/Detail.cshtml
@using Lifestoned.DataModel.Gdle
@using Lifestoned.DataModel.Shared
@model Weenie

@{
    ViewBag.Title = "Detail";
}

@section metaCard {
    <meta property="og:type" content="website" />
    <meta property="og:title" content="@(Model.Name)" />
    <meta property="og:image" content="@Url.Action("GetFullyLayeredPngIcon", "Resource", new { weenieClassId = Convert.ToUInt32(Model.WeenieClassId) })" />
}

<br />

<div class="btn-toolbar stuck">
    <div class="btn-group-vertical" role="group">
        <a id="preview" target="_blank" href="http://ac.yotesfan.com/10-Clothing/preview.php?id={{cid}}&setup={{sid}}&pal={{pid}}" class="btn btn-primary" title="preview"><i class="glyphicon glyphicon-search"></i></a>
    </div>
    <div class="btn-group-vertical" role="group">
        <a id="btnViewAppraise" class="btn btn-primary" title="View Appraisal Panel"><i class="glyphicon glyphicon-eye-open"></i></a>
    </div>

    <ul class="btn-group-vertical nav" role="group">
        <li class="active"><a data-toggle="tab" href="#general" class="btn btn-primary" title="General Properties"><i class="glyphicon glyphicon-list"></i></a></li>
        <li><a data-toggle="tab" href="#creature" class="btn btn-primary" title="Creature Properties"><i class="glyphicon glyphicon-user"></i></a></li>
        <li><a data-toggle="tab" href="#book" class="btn btn-primary" title="Book Pages"><i class="glyphicon glyphicon-book"></i></a></li>
        <li><a data-toggle="tab" href="#createlist" class="btn btn-primary" title="Create List"><i class="glyphicon glyphicon-briefcase"></i></a></li>
        <li><a data-toggle="tab" href="#generator" class="btn btn-primary" title="Generated Items"><i class="glyphicon glyphicon-duplicate"></i></a></li>
        <li><a data-toggle="tab" href="#emote" class="btn btn-primary" title="Emotes"><i class="glyphicon glyphicon-warning-sign"></i></a></li>
        <li><a data-toggle="tab" href="#history" class="btn btn-primary" title="Change Log / History"><i class="glyphicon glyphicon-calendar"></i></a></li>
    </ul>
</div>

<div id="app" class="form-horizontal">
    <lsd-weenie ref="weenie" v-model="$weenie.weenie"></lsd-weenie>
</div>

@section scripts {
    @Html.Partial("EditorScript")

    @Scripts.Render("~/bundles/vue", "~/ui/shared", "~/ui/weenie")
    <script>
        Vue.use(WeenieStore);
        var weenieStore = makeWeenieService(@(Model.WeenieClassId), false, '@ViewBag.UserGuid');

        Vue.use(AutoWatchMixin);

        var app = new Vue({
            el: '#app',
            weenieStore: weenieStore
        });

    </script>
}

DerethForever.Web/Views/Weenie/Edit.cshtml
@using Lifestoned.DataModel.Gdle;
@using Lifestoned.DataModel.Shared
@model Weenie

@{
    ViewBag.Title = "Edit " + Model.Name;
}

<br />

@using (Html.BeginForm("Edit", "Weenie", FormMethod.Post))
{
    @Html.AntiForgeryToken()

<div class="btn-toolbar stuck">
    <div class="btn-group-vertical" role="group">
        <button id="btnSave" type="button" class="btn btn-primary" title="Save"><i class="glyphicon glyphicon-floppy-save"></i></button>
        <a href="@Url.Action("Edit", "Weenie", new { id = Model.WeenieClassId })" class="btn btn-primary" title="Cancel"><i class="glyphicon glyphicon-remove"></i></a>
        @if (User.IsInRole("Admin"))
        {
            <a href="@Url.Action("Delete", "Weenie", new { id = Model.WeenieClassId })" class="btn btn-primary" title="Delete"><i class="glyphicon glyphicon-trash"></i></a>
        }
        <a id="preview" target="_blank" href="http://ac.yotesfan.com/10-Clothing/preview.php?id={{cid}}&setup={{sid}}&pal={{pid}}" class="btn btn-primary" title="preview"><i class="glyphicon glyphicon-search"></i></a>
    </div>
    <div class="btn-group-vertical" role="group">
        <a id="btnViewAppraise" class="btn btn-primary" title="View Appraisal Panel"><i class="glyphicon glyphicon-eye-open"></i></a>
    </div>

    <ul class="btn-group-vertical nav" role="group">
        <li class="active"><a data-toggle="tab" href="#general" class="btn btn-primary" title="General Properties"><i class="glyphicon glyphicon-list"></i></a></li>
        <li><a data-toggle="tab" href="#creature" class="btn btn-primary" title="Creature Properties"><i class="glyphicon glyphicon-user"></i></a></li>
        <li><a data-toggle="tab" href="#book" class="btn btn-primary" title="Book Pages"><i class="glyphicon glyphicon-book"></i></a></li>
        <li><a data-toggle="tab" href="#createlist" class="btn btn-primary" title="Create List"><i class="glyphicon glyphicon-briefcase"></i></a></li>
        <li><a data-toggle="tab" href="#generator" class="btn btn-primary" title="Generated Items"><i class="glyphicon glyphicon-duplicate"></i></a></li>
        <li><a data-toggle="tab" href="#emote" class="btn btn-primary" title="Emotes"><i class="glyphicon glyphicon-warning-sign"></i></a></li>
        <li><a data-toggle="tab" href="#history" class="btn btn-primary" title="Change Log / History"><i class="glyphicon glyphicon-calendar"></i></a></li>
    </ul>
</div>

    <div id="app" class="form-horizontal">
        <lsd-weenie ref="weenie" v-model="$weenie.weenie"></lsd-weenie>
    </div>

}

@section scripts {
    @Html.Partial("EditorScript")

    @Scripts.Render("~/bundles/vue", "~/ui/shared", "~/ui/weenie")
    <script>
        Vue.use(WeenieStore);
        var weenieStore = makeWeenieService(@(Model.WeenieClassId));

        Vue.use(AutoWatchMixin);

        var app = new Vue({
            el: '#app',
            weenieStore: weenieStore
        });

        function validate() {
            var cl = weenieStore.weenie.UserChangeSummary;
            if (!cl || cl.length == 0) {
                $("a[href='#history']").click();
                alert("Update Change Log before saving");
                return false;
            } else {
                return true;
            }
            return true;
        }

        $(document).ready(function () {
            $('#btnSave').click(function (e) {
                if (validate())
                    weenieStore.save();

                e.preventDefault();
                e.stopPropagation();
            });
        });
    </script>
}

DerethForever.Web/Views/Weenie/LogIntoManagedWorld.cshtml
@using DerethForever.Web.Controllers
@model DerethForever.Web.Models.Weenie.DownloadChangeModel

@{
    ViewBag.Title = "Log in to Managed Server";
}

<h2>Log in to Managed Server</h2>

<br />

@using (Html.BeginForm("LogIntoManagedWorld", "Weenie", FormMethod.Post))
{
    @Html.HiddenFor(m => m.FromUserGuid)
    @Html.HiddenFor(m => m.WeenieId)
    @Html.HiddenFor(m => m.TargetServerGuid)
    @Html.HiddenFor(m => m.PreviewOnly)

    @Html.DisplayFor(m => m, "InfoMessages")

    <div class="well">
        <div class="row row-spacer">
            <div class="col-md-2 col-md-offset-2">
                @Html.Label("Username")
            </div>
            <div class="col-md-3">
                @Html.TextBoxFor(m => m.TargetServerUsername, new { @class = "form-control" })
            </div>
        </div>
        <div class="row row-spacer">
            <div class="col-md-2 col-md-offset-2">
                @Html.Label("Password")
            </div>
            <div class="col-md-3">
                @Html.PasswordFor(m => m.TargetServerPassword, new { @class = "form-control" })
            </div>
        </div>
        <div class="row row-spacer">
            <div class="col-md-2 col-md-offset-4">
                <input type="submit" value="Log In" class="btn btn-primary" />
            </div>
        </div>
    </div>
}

DerethForever.Web/Views/Weenie/New.cshtml
@using Lifestoned.DataModel.Gdle;
@using Lifestoned.DataModel.Shared
@model Weenie

@{
    ViewBag.Title = "Create " + Model.Name;
}

<br />

@using (Html.BeginForm(Model.IsCloneMode ? "Clone" : "New", "Weenie", FormMethod.Post))
{
    @Html.AntiForgeryToken()

    <div class="btn-toolbar stuck">
        <div class="btn-group-vertical" role="group">
            <button id="btnSave" type="button" class="btn btn-primary" title="Save"><i class="glyphicon glyphicon-floppy-save"></i></button>
            <a href="@Url.Action("Edit", "Weenie", new { id = Model.WeenieClassId })" class="btn btn-primary" title="Cancel"><i class="glyphicon glyphicon-remove"></i></a>
            @if (User.IsInRole("Admin"))
            {
                <a href="@Url.Action("Delete", "Weenie", new { id = Model.WeenieClassId })" class="btn btn-primary" title="Delete"><i class="glyphicon glyphicon-trash"></i></a>
            }
            <a id="preview" target="_blank" href="http://ac.yotesfan.com/10-Clothing/preview.php?id={{cid}}&setup={{sid}}&pal={{pid}}" class="btn btn-primary" title="preview"><i class="glyphicon glyphicon-search"></i></a>
        </div>

        <ul class="btn-group-vertical nav" role="group">
            <li class="active"><a data-toggle="tab" href="#general" class="btn btn-primary" title="General Properties"><i class="glyphicon glyphicon-list"></i></a></li>
            <li><a data-toggle="tab" href="#creature" class="btn btn-primary" title="Creature Properties"><i class="glyphicon glyphicon-user"></i></a></li>
            <li><a data-toggle="tab" href="#book" class="btn btn-primary" title="Book Pages"><i class="glyphicon glyphicon-book"></i></a></li>
            <li><a data-toggle="tab" href="#createlist" class="btn btn-primary" title="Create List"><i class="glyphicon glyphicon-briefcase"></i></a></li>
            <li><a data-toggle="tab" href="#generator" class="btn btn-primary" title="Generated Items"><i class="glyphicon glyphicon-duplicate"></i></a></li>
            <li><a data-toggle="tab" href="#emote" class="btn btn-primary" title="Emotes"><i class="glyphicon glyphicon-warning-sign"></i></a></li>
            <li><a data-toggle="tab" href="#history" class="btn btn-primary" title="Change Log / History"><i class="glyphicon glyphicon-calendar"></i></a></li>
        </ul>
    </div>

    <div id="app" class="form-horizontal">
        <lsd-weenie ref="weenie" v-model="$weenie.weenie"></lsd-weenie>
    </div>

}

@section scripts {
    @Html.Partial("EditorScript")

    @Scripts.Render("~/bundles/vue", "~/ui/shared", "~/ui/weenie")
    <script>
        Vue.use(WeenieStore);
        var weenieStore = makeWeenieService(@(Model.WeenieClassId), @(Model.IsCloneMode ? "true" : "false"), '@ViewBag.UserGuid');

        Vue.use(AutoWatchMixin);

        var app = new Vue({
            el: '#app',
            weenieStore: weenieStore
        });

        function validate() {
            if (!weenieStore.validate()) {
                alert('Please fill required fields');
                return false;
            }

            var cl = weenieStore.weenie.UserChangeSummary;
            if (!cl || cl.length == 0) {
                $("a[href='#history']").click();
                alert("Update Change Log before saving");
                return false;
            } else {
                return true;
            }
            return true;
        }

        $(document).ready(function () {
            $('#btnSave').click(function (e) {
                if (validate())
                    weenieStore.save();

                e.preventDefault();
                e.stopPropagation();
            });
        });
    </script>
}

DerethForever.Web/Views/Weenie/SelectManagedWorld.cshtml
@using DerethForever.Web.Controllers
@model DerethForever.Web.Models.Weenie.DownloadChangeModel

@{
    ViewBag.Title = "Send Weenie to Managed Server";
}

<h2>Send Weenie to Managed Server</h2>

<br/>

@if (Model.TargetServerGuid == null)
{
    using (Html.BeginForm("SelectDfServer", "Weenie", FormMethod.Post))
    {
        @Html.HiddenFor(m => m.FromUserGuid)
        @Html.HiddenFor(m => m.WeenieId)
        @Html.HiddenFor(m => m.PreviewOnly)
        @Html.DropDownListFor(m => m.TargetServerGuid, BaseController.CurrentUser.ManagedWorldSelectListItems, "Select a Server", new { @class = "form-control" })
    }
}
else 
{
    <div class="alert alert-warning">
        You have reached this page in error.  Please file a bug report.
    </div>
}